function PuzzleGame() {
    var self = this;
    self.hasStarted = false;

    self.currentPuzzleChoice = 1;

    self.selectedPiece = null;
    self.moves = 0;

    self.start = function () {

        //Hide the main lobby and show the puzzle chooser
        $(".game-lobby").removeClass("hide");
        $(".game--puzzle").removeClass("show");

        $('.selection').removeClass("show");
        $('.chooser--puzzle').addClass("show");        

    };

    self.hide = function () {
        $('.selection').addClass("show");
        $('.chooser--puzzle').removeClass("show");

        router.push("/", "Hairy Maclary");
    };

    self.handleCentering = function (ev, obj) {
        if (obj.activeDropRegions.length > 0) {
            self.centerWithin(obj);
        }
    };

    self.setupDragHandlers = function () {
        var items = $('#puzzleGame .piece');

        var multiplier = 1;
        /*var windowWidth = $(window).width();

        if (windowWidth < 1200) {
            multiplier = 1.3;
        }

        if (windowWidth < 680) {
            multiplier = 3;
        }*/



        for (var i = 0; i < items.length; i++) {            

            $('.piece' + (i + 1)).pep({
                droppable: '.dropboard__target[data-target=' + (i + 1) + ']',
                shouldEase: false,                
                start: function (ev, obj) {
                    obj.noCenter = false;
                    obj.$el.addClass('active');
                },
                stop: function (ev, obj) {
                    self.handleCentering(ev, obj);
                    return true;
                },
                rest: function (ev, obj) {
                    if (ev.screenY <= 150 || ev.screenY >= $(window).height()) {
                        setTimeout(function () {
                            obj.cssX = 0;
                            obj.cssY = 0;
                            obj.$el.removeAttr('style');
                        }, 500);
                        return true;
                    }

                    if (ev.pageX <= 100 || ev.pageX >= ($(window).width() - 100)) {
                        setTimeout(function () {
                            obj.cssX = 0;
                            obj.cssY = 0;
                            obj.$el.removeAttr('style');
                        }, 500);
                        return true;
                    }
                },
                multiplier: multiplier
            });
        }
    };

    self.centerWithin = function (obj) {
        var $parent = obj.activeDropRegions[0];
        var pTop = $parent.position().top;
        var pLeft = $parent.position().left;
        var pHeight = $parent.outerHeight();
        var pWidth = $parent.outerWidth();

        var oTop = obj.$el.position().top;
        var oLeft = obj.$el.position().left;
        var oHeight = obj.$el.outerHeight();
        var oWidth = obj.$el.outerWidth();

        var cTop = pTop + (pHeight / 2);
        var cLeft = pLeft + (pWidth / 2);

        var topDiff = Math.abs(cTop - (oTop + (oHeight / 2)));
        var leftDiff = Math.abs(cLeft - (oLeft + (oWidth / 2)));

        if ($(window).width() < 1200) {
            topDiff = topDiff * 0.7;
            leftDiff = leftDiff * 0.7;
        }

        var topOffset = 50;
        var leftOffset = 50;

        if (!Modernizr.csstransforms) {
            leftOffset = 100;
        }

        if ((topDiff < topOffset) && (leftDiff < leftOffset)) {
            obj.$el.removeAttr('style').addClass('stuck pulse');
            obj.$el.css('z-index', '1');

            setTimeout(function () {
                obj.$el.removeAttr('style').addClass('stuck pulse');
                obj.$el.css('z-index', '1');
            }, 500);

            obj.toggle();
            self.moves++;
        }

        if (self.moves === 20) {
            self.puzzleComplete();
        }
    };

    self.loadPuzzle = function (e, puzzleToLoad) {   
        console.log("load puzzle");                

        $('.dialog--puzzle-results').hide();
        
        $('.puzzle').removeClass('slinky hairyzac alldogs scarface muffin').css('opacity', 1);;
        $('.piece').removeAttr('style').removeClass('active stuck pulse');

        self.moves = 0;

        var puzzleClass = puzzleToLoad === undefined ? $(this).attr('class') : puzzleToLoad;
        router.push("/puzzles/" + puzzleClass, "Hairy Maclary - Puzzles");

        $('.puzzle').addClass(puzzleClass);        

        /* Hide puzzle chooser and show puzzle board */
        $('.game-lobby').addClass('hide');
        $('.game--puzzle').addClass('show');


        $.pep.toggleAll(true);

        // Reset all pieces so they don't snap right into their correct positions
        for (var i = 0; i < $.pep.peps.length; i++) {
            $.pep.peps[i].cssX = 0;
            $.pep.peps[i].cssY = 0;
            $.pep.peps[i].translation = '';
        }


    };

    self.puzzleComplete = function () {
        setTimeout(function () {
            $('.puzzle').css('opacity', 0.5);
            $('.dialog--puzzle-results').show();
        }, 250);
    };

    self.playAgain = function () {
        $('.game-lobby').removeClass('hide').addClass('show');
        $('.game--puzzle').removeClass('show').addClass('hide');

        games.puzzles.start();
        router.push("/puzzles", "Hairy Maclary - Puzzles");
    };


    //Init interaction
    $('.chooser--puzzle li').hammer().on('tap', self.loadPuzzle);
    
    /*$('#puzzleSelection button.backbutton').hammer().on('tap', self.hide);
    $('#btnPuzzle_PlayAgain').hammer().on('tap', self.playAgain);*/

    self.setupDragHandlers();
}

$(function () {
    games.puzzles = new PuzzleGame();
});