function SpotTheDifference() {
    var self = this;

    self.differencesLeft = 6;
    self.marker = $('.marker');

    self.start = function () {
        //Hide the main lobby and show the puzzle chooser
        $(".game-lobby").removeClass("hide");
        $(".game--difference").removeClass("show");

        $('.selection').removeClass("show");
        $('.chooser--spothedifference').addClass("show");   
    };


    self.choosePuzzle = function (e, puzzleToLoad) {
        var puzzleName = puzzleToLoad === undefined ? $(this).attr('class') : puzzleToLoad;
        router.push("/spotthedifference/" + puzzleName, "Hairy Maclary - Spot the difference");

        $('.dialog--difference-results').hide();

        //Initialise the playing surface
        $('#spotTheDifference .side.right .spot').remove();
        $('#spotTheDifference div.container').removeClass('slinky shoo showbusiness').addClass(puzzleName);

        self.differencesLeft = 6;
        $('#differencesLeft').html(self.differencesLeft);
        
        $('#spotTheDifference .container').show().css('opacity',1);
        
        

        $('#spotTheDifference .marked').removeClass('marked expandout');

        var spots = $('#spotTheDifference .spot');

        for (var i = 0; i < spots.length; i++) {
            var spot = spots[i];
            $(spot).clone().appendTo('#spotTheDifference .side.right');
        }

        $('#spotTheDifference .spot').hammer().on('tap', self.tapDifference);
        $('#spotTheDifference div.container div.side').hammer().on('tap', self.tapBoard);

        //Hide the lobby, show the game
        $('.game-lobby').addClass('hide');
        $('.game--difference').removeClass('hide').addClass('show');
    };

    self.tapDifference = function () {
        if ($(this).hasClass('marked')) {
            return;
        }

        $('.' + $(this).attr('class').split(' ')[1]).addClass('expandout marked');

        self.differencesLeft--;
        $('#differencesLeft').html(self.differencesLeft);

        if (self.differencesLeft === 1) {
            $('.morethanone').addClass('hidden');
            $('.oneleft').removeClass('hidden');
        } else {
            $('.morethanone').removeClass('hidden');
            $('.oneleft').addClass('hidden');
        }

        if (self.differencesLeft === 0) {
            setTimeout(function() {
                self.puzzleComplete();
            }, 250);
        }

        return false;
    };

    self.tapBoard = function (ev) {
        self.marker
            .css('top', (ev.gesture.center.pageY - (self.marker.width() / 2) + 'px'))
            .css('left', ev.gesture.center.pageX - (self.marker.height() / 2) + 'px')
            .addClass('expandout red')
            .show();

        setTimeout(function () {
            self.marker.hide().removeClass('expandout');
        }, 500);
    };

    self.puzzleComplete = function () {
        $('.dialog--difference-results').show();
        $('#spotTheDifference .container').show().css('opacity',.5);
    };

    self.playAgain = function () {
        $('.game-lobby').removeClass('hide').addClass('show');
        $('.game--difference').removeClass('show').addClass('hide');

        router.push("/spotthedifference", "Hairy Maclary");
    };

    //Init interaction
    $('.chooser--spothedifference li').hammer().on('tap', self.choosePuzzle);
    $('.button--difference-playagain').hammer().on('tap', self.start);
}

$(function () {
    games.spotTheDifference = new SpotTheDifference();
});